class BULLET
inherit
	TICKABLE
		redefine
			make,
			can_adjacent_shoot,
			shot,
			die,
			player_touch
		end
	DIRECTION
creation make, make_for_world, make_shoot
feature
	aim : INTEGER
	owner : INTEGER
		-- 0 = player
		-- 1 = other

	make(initial_square : like square) is
	do
		square := initial_square
		if square /= Void then
			square.put_monster(Current)
		--else if Void then it means we're shooting
		end
		put_chr(248)
		put_colour(15)
	end

	read_init_rest(header : OBJECT_HEADER) is
	do
		owner := header.p1
		aim := direction_from_xy(header.xstep, header.ystep)
		if owner = 0 then
			square.map.increment_bullet_count
		end
	end

	make_shoot(sq : SQUARE; aim_init : INTEGER; owner_init : INTEGER) is
	do
		make(Void)
		cycle := 1
		cycle_count := 1
		aim := aim_init
		owner := owner_init

		life_flag := false
		sq.adjacent(aim).dominant.shot(Current)
		if life_flag then
			if owner = 0 then
				sq.map.increment_bullet_count
			end
			sq.map.tick_list.add_last(Current)
			ticker_on
		end
	end

	can_adjacent_shoot : BOOLEAN is true

	shot(b : BULLET) is
	do
		die
	end

	die is
	do
		Precursor
		if owner = 0 then
			square.map.decrement_bullet_count
		end
	end

	life_flag : BOOLEAN
	set_life_flag is
	do
		life_flag := true
	end

	reverse_aim is
	do
		aim := opposite_direction(aim)
	end
	
	cycle_tick is
	do
		life_flag := false
		square.adjacent(aim).dominant.shot(Current)
		if not life_flag then
			die
		end
	end

	player_touch(p : PLAYER) is
	do
		p.shot(Current)
		die
	end

	kind : STRING is "bullet"
	zzt_code : INTEGER is 18
end
