class CONVEYOR
inherit
	DIRECTION
	TICKABLE
feature
	read_init_rest(header : OBJECT_HEADER) is
	do
	end

	animation_cycle : INTEGER

	cycle_tick is
	do
		if animation_cycle = 3 then
			animation_cycle := 0
		else
			animation_cycle := animation_cycle + 1
		end
		put_chr(conveyor_chr.item(animation_cycle))
		convey
	end

	convey is
	local
		i : INTEGER
		found : BOOLEAN
		sq : SQUARE
		x, y : INTEGER
		board : ARRAY2[SQUARE]
	do
		-- first find an "empty" or unconveyable thing
		-- if there isn't one, we rotate everything
		x := square.location.x
		y := square.location.y
		board := square.map.board
		from i := 1
		until found or else i > 8
		loop
			sq := board.item(x + offset.item(i) @ 1, y + offset.item(i) @ 2)
			if sq.dominant.kind.is_equal("empty") then
				found := true
			elseif not sq.dominant.can_convey_me then
				found := true
			else
				i := i + 1
			end
		end
		if found then
			convey_from(i)
		else
			-- rotate everything
		end
	end

	convey_from(start : INTEGER) is
	local
		count : INTEGER
		sq, sq_prev : SQUARE
		i : INTEGER
		x, y : INTEGER
		board : ARRAY2[SQUARE]
		ignore : BOOLEAN
	do
		x := square.location.x
		y := square.location.y
		board := square.map.board

		i := start
		sq := board.item(x + offset.item(i) @ 1, y + offset.item(i) @ 2)
		from count := 1
		until count >= 8
		loop
			i := i - 1
			if i <= 0 then i := 8 end
			sq_prev := board.item(x + offset.item(i) @ 1, y + offset.item(i) @ 2)
			if sq.dominant.kind.is_equal("empty") then
				from
				until not sq_prev.dominant.can_convey_me or else count >= 8
				loop
					ignore := sq_prev.dominant.try_push(offset.item(i) @ 3)
					count := count + 1
					sq := sq_prev
					i := i - 1
					if i <= 0 then i := 8 end
					sq_prev := board.item(x + offset.item(i) @ 1, y + offset.item(i) @ 2)
				end
				count := count + 1
				sq := sq_prev
			elseif not sq.dominant.can_convey_me then
				from
				until sq_prev.dominant.kind.is_equal("empty") or else count >= 8
				loop
					count := count + 1
					sq := sq_prev
					i := i - 1
					if i <= 0 then i := 8 end
					sq_prev := board.item(x + offset.item(i) @ 1, y + offset.item(i) @ 2)
				end
				count := count + 1
				sq := sq_prev
			else
				-- bug
				io.put_string("Uh oh: bug in convey_from%N")
				die_with_code(1)
			end
		end
	end

feature {NONE}

	conveyor_chr : ARRAY[INTEGER] is
	deferred
	end

	offset : ARRAY[ARRAY[INTEGER]] is
	deferred
	end

	make_arr(i, j, k : INTEGER) : ARRAY[INTEGER] is
	do
		!!Result.make(1, 3)
		Result.put(i, 1)
		Result.put(j, 2)
		Result.put(k, 3)
	end
end
