class MAP
inherit
	MAP_ABSTRACT
		redefine square
		end
	DIRECTION
	READ_TOOL
creation make
feature
	square : SQUARE

	tick_list : LINKED_LIST[THING]
	object_list : LINKED_LIST[OBJECT]

	init_start_square : like start_square

	title : STRING
	put_title(s : STRING) is
	do
		title := s
	end

	width : INTEGER is 60
	height : INTEGER is 25

	board : ARRAY2[SQUARE]

	max_shot : INTEGER
	dark : BOOLEAN
	reenter : BOOLEAN
	time_limit : INTEGER

	neighbour : ARRAY[INTEGER]

	world : WORLD
	make(w : WORLD) is
	local
	do
		world := w
		!!map.make(1, 1)
		!!board.make(1, width, 1, height)
		map.put(board, 1)
		!!neighbour.make(1, 4)
		!!object_list.make
	end

	at(l : LOCATION) : SQUARE is
	do
		Result := board.item(l.x, l.y)
	end

	read_board is
	local
		i : INTEGER
		j : INTEGER
		x, y : INTEGER
		code : INTEGER
		colour : INTEGER
		size : INTEGER
		bsize : INTEGER
		sq : SQUARE
		t : THING
		m : MONSTER_OBJECT
		ter : TERRAIN
		loc : LOCATION
	do
		io.put_string(global_offset.to_hexadecimal)
		io.put_string(": begin board%N")
		offset := 0
		read_2
		bsize := last_integer
		if verbose_flag then
			io.put_string(global_offset.to_hexadecimal)
			io.put_string(": board size = ")
			io.put_integer(bsize)
			io.put_string("%N")
		end
		bsize := bsize + global_offset
		
		read_1
		size := last_character.code
		!!title.make(size)
		from i := 1
		until i > size
		loop
			read_1
			title.add_last(last_character)
			i := i + 1
		end
		read_until(52) -- 34h (zztff.txt is wrong, it should be 34 not 33)
		read_1

		x := 1
		y := 1
		from i := 0
		until i = width * height
		loop
			read_1
			size := last_character.code
			read_1
			code := last_character.code
			read_1
			colour := last_character.code
			from j := 1
			until j > size
			loop
				--!!sq.make(Current, integers_to_location(x, y, 1))
				!!loc.make(x, y, 1)
				!!sq.make(Current, loc)
				put(code, colour, sq)

		--if verbose_flag then
			--io.put_string("(")
			--io.put_integer(x)
			--io.put_string(", ")
			--io.put_integer(y)
			--io.put_string("): code, colour = ")
			--io.put_integer(code)
			--io.put_string(", ")
			--io.put_integer(colour)
			--io.put_string("%N")
		--end
				x := x + 1
				if x > width then
					x := 1
					y := y + 1
				end
				j := j + 1
			end
			i := i + size
		end

		offset := 0
		read_1
		max_shot := last_character.code
		read_1
		dark := last_character.code = 1
		from i := 1
		until i > 4
		loop
			read_1
			neighbour.put(last_character.code, i)
			i := i + 1
		end
		read_1
		reenter := last_character.code = 1
		read_until(68)
		read_2
		time_limit := last_integer
		read_until(86)
		read_2
		size := last_integer -- object count

		--read player
		offset := 0
		read_1
		x := last_character.code
		read_1
		y := last_character.code
		if board.item(x, y) /= start_square then
			std_error.put_string("Error: player information missing%N")
			die_with_code(exit_failure_code)
		end
		--io.put_string("start square = (")
		--io.put_integer(x)
		--io.put_string(", ")
		--io.put_integer(y)
		--io.put_string(")%N")
		header.read
		put(header.ut, header.uc, board.item(x, y))
		player_header := clone(header)

		from i := 1
		until i > size
		loop
		--io.put_string("Bytes left in board = ")
		--io.put_integer(bsize - global_offset)
		--io.put_string("%N")
			header.put_object_number(i)
			offset := 0
			read_1
			x := last_character.code
			read_1
			y := last_character.code
			--if verbose_flag then
				--io.put_string(global_offset.to_hexadecimal)
				--io.put_string(": object #")
				--io.put_integer(i)
				--io.put_string("/")
				--io.put_integer(size)
				--io.put_string(" (")
				--io.put_integer(x)
				--io.put_string(", ")
				--io.put_integer(y)
				--io.put_string(")%N")
			--end
			if board.valid_index(x, y) then
				--m ?= board.item(x, y).monster
				m ?= board.item(x, y).layer @ 2
				if m = Void then
					io.put_string("No object at (")
					io.put_integer(x)
					io.put_string(", ")
					io.put_integer(y)
					io.put_string("); parsing anyway%N")
					header.read
				else
					header.read
					ter ?= world.thing_code @ header.ut
					if ter = Void then
						io.put_string("Non-terrain thing under object; ignoring%N")
						put(0, 0, board.item(x, y))
					else
						put(header.ut, header.uc, board.item(x, y))
					end
					m.read_init(header)
				end
			else
				io.put_string("Invalid coordinates (")
				io.put_integer(x)
				io.put_string(", ")
				io.put_integer(y)
				io.put_string("); parsing anyway%N")
				header.read
			end

			i := i + 1
		end
		bsize := bsize - global_offset
		if bsize /= 0 then
			io.put_string(global_offset.to_hexadecimal)
			io.put_string(": board size mismatch = ")
			io.put_integer(bsize)
			io.put_string("%N")
			die_with_code(exit_failure_code)
		end

		if size - i + 1 /= 0 then
			io.put_string(global_offset.to_hexadecimal)
			io.put_string(": warning - missing objects%N")
			die_with_code(exit_failure_code)
		end
		init_tick_list
	end

	adjacent(sq : SQUARE; dir : INTEGER) : SQUARE is
	local
		loc : LOCATION
	do
		loc := sq.location
		inspect dir
		when north then
			if loc.y = 1 then
				Result := sentinel.item(north)
			else
				Result := board.item(loc.x, loc.y - 1)
			end
		when south then
			if loc.y = height then
				Result := sentinel.item(south)
			else
				Result := board.item(loc.x, loc.y + 1)
			end
		when west then
			if loc.x = 1 then
				Result := sentinel.item(west)
			else
				Result := board.item(loc.x - 1, loc.y)
			end
		when east then
			if loc.x = width then
				Result := sentinel.item(east)
			else
				Result := board.item(loc.x + 1, loc.y)
			end
		end
	end
	
	is_legal_coord(x, y : INTEGER) : BOOLEAN is
	do
		Result := x >= 1 and then x <= width
			and then y >= 1 and then y <= height
	end
feature {NONE}
	sentinel : ARRAY[SQUARE] is
	local
		i : INTEGER
		sq : SQUARE
		sen : SENTINEL
	once
		!!Result.make(min_dir, max_dir)
		from i := min_dir
		until i > max_dir
		loop
			!!sq.make(Void, Void)
			!!sen.make(sq)
			sen.put_direction(i)
			Result.put(sq, i)
			i := i + 1
		end
	end

	put(code, colour : INTEGER; sq : SQUARE) is
	local
		wall : WALL
		floor : FLOOR
		object : OBJECT
		t : THING
	do
		t := world.thing_code @ code
		if t /= Void then
			t.add_to_map(Current, sq, colour)
		else
			inspect code
			when 1 then -- floor
				!!floor.make(sq)
				floor.put_colour(colour)
				io.put_string("Warning: I don't know what 1 is exactly%N")
			when 4 then -- player
				!!floor.make(sq)
				floor.put_colour(colour)
				init_start_square := sq
				start_square := init_start_square
			else
				if code >= 47 and then code <= 61 then -- text
					!TEXT!wall.make(sq)
					wall.put_chr(colour)
					wall.put_colour(16 * (code - 46) + 15)
					if code = 53 then
						wall.put_colour(15)
					end
				else
					io.put_string("Warning: unknown object: ")
					io.put_integer(code)
					io.put_string(" (")
					io.put_integer(sq.location.x)
					io.put_string(", ")
					io.put_integer(sq.location.y)
					io.put_string(")%N")
					!UNKNOWN!t.make(sq)
					t.put_colour(colour)
				end
			end
		end
	end

	init_tick_list is
	local
		x, y : INTEGER
		i : INTEGER
		i1, i2 : INTEGER
		sq : SQUARE
		list : ARRAY[THING]
		t : THING
	do
		!!tick_list.make
		from x := 1
		until x > width
		loop
			from y := 1
			until y > height
			loop
				sq := board.item(x, y)

				list := sq.layer
				i1 := list.lower
				i2 := list.upper
				from i := i1
				until i > i2
				loop
					t := list @ i
					if t /= Void and then t.ticking then
						tick_list.add_last(t)
					end
					i := i + 1
				end
				y := y + 1
			end
			x := x + 1
		end
	end

	header : OBJECT_HEADER is
	once
		!!Result.make
	end

	player_header : OBJECT_HEADER

feature {SQUARE}
	world_adjacent(sq : SQUARE; dir : INTEGER) : SQUARE is
		--takes neighbouring boards into account
	local
		loc : LOCATION
		nbr : ARRAY2[SQUARE]
	do
		loc := sq.location

		inspect dir
		when north then
			if loc.y = 1 then
				nbr := get_neighbour(north)
				if nbr = Void then
					Result := sentinel.item(north)
				else
					Result := nbr.item(loc.x, height)
				end
			else
				Result := board.item(loc.x, loc.y - 1)
			end
		when south then
			if loc.y = height then
				nbr := get_neighbour(south)
				if nbr = Void then
					Result := sentinel.item(south)
				else
					Result := nbr.item(loc.x, 1)
				end
			else
				Result := board.item(loc.x, loc.y + 1)
			end
		when west then
			if loc.x = 1 then
				nbr := get_neighbour(west)
				if nbr = Void then
					Result := sentinel.item(west)
				else
					Result := nbr.item(width, loc.y)
				end
			else
				Result := board.item(loc.x - 1, loc.y)
			end
		when east then
			if loc.x = width then
				nbr := get_neighbour(east)
				if nbr = Void then
					Result := sentinel.item(east)
				else
					Result := nbr.item(1, loc.y)
				end
			else
				Result := board.item(loc.x + 1, loc.y)
			end
		end
	end

feature {NONE}
	get_neighbour(d : INTEGER) : ARRAY2[SQUARE] is
	do
		Result := world.board_list.item(neighbour @ d).board
	end

feature {OBJECT}
	
	change(code1 : INTEGER; s1 : STRING; code2 : INTEGER; s2 : STRING) is
	require
		world.thing_table.has(s1) and world.thing_table.has(s2)
	local
		x, y : INTEGER
		t1, t2 : THING
		colour : INTEGER
		sq : SQUARE
	do
		--io.put_string("Looking for: ")
		--io.put_string(s1)
		--io.put_string("%N")
		from x := 1
		until x > width
		loop
			from y := 1
			until y > height
			loop
				sq := board.item(x, y)
				t1 := sq.dominant
				if t1.kind.is_equal(s1) and then
						(code1 = -1 or else t1.has_colour_code(code1)) then
					--io.put_string("(")
					--io.put_integer(x)
					--io.put_string(", ")
					--io.put_integer(y)
					--io.put_string(") = ")
					--io.put_string(t1.kind)
					--io.put_string(" ==> match%N")
					-- change it
					if s1.is_equal(s2) then
						if code2 /= -1 then
							t1.put_colour_code(code2)
						end
					else
						t2 := world.thing_table.at(s2)
						sq.clear
						if code2 = -1 then
							colour := t1.colour
						else
							colour := t2.colour_code_to_colour(code2)
						end
						t2.add_to_map(Current, sq, colour)
					end
				end
				y := y + 1
			end
			x := x + 1
		end
	end

	find_first(c : INTEGER; s : STRING) : THING is
	require
		world.thing_table.has(s)
	local
		found : BOOLEAN
		x, y : INTEGER
		t : THING
	do
		from y := 1
		until found or else y > height
		loop
			from x := 1
			until found or else x > width
			loop
				t := board.item(x, y).dominant
				if t.kind.is_equal(s) and then
						(c = -1 or else t.has_colour_code(c)) then
					found := true
					Result := t
				end
				x := x + 1
			end
			y := y + 1
		end
	end

feature {ZZT}
	bullet_count : INTEGER

feature {BULLET}
	increment_bullet_count is
	do
		bullet_count := bullet_count + 1
	end

	decrement_bullet_count is
	do
		bullet_count := bullet_count - 1
	end

end
