deferred class THING
inherit
	THING_ABSTRACT
		redefine square
		end
feature
	square : SQUARE

	make(sq : SQUARE) is
	deferred
	end

	direction : INTEGER

	colour : INTEGER
	put_colour(c : INTEGER) is
	do
		colour := c
		fg := c \\ 16
		bg := c // 16
		if bg >= 8 then
			bg := bg - 8
		end
	end

	bg, fg : INTEGER
	put_fg(new_fg : INTEGER) is
	do
		fg := new_fg
		colour := fg + 16 * bg
	end
	put_bg(new_bg : INTEGER) is
	do
		bg := new_bg
		colour := fg + 16 * bg
	end

	-- colour codes are used when
	-- object programs specify colours
	has_colour_code(c : INTEGER) : BOOLEAN is
	do
		inspect colour_method
		when 0 then
			Result := c + 8 = fg
		when 1 then
			Result := c = bg
		end
	end
	colour_code_to_colour(c : INTEGER) : INTEGER is
		---- keep old bg/fg colour unchanged
		-- not any more! I think ZZT changes
		-- the old bg/fg to white or black
		-- (depends on the method used)
	do
		inspect colour_method
		when 0 then
			--Result := c + 8 + 16 * bg
			Result := c + 8
		when 1 then
			--Result := fg + 16 * c
			Result := 15 + 16 * c
		end
	end

	put_colour_code(c : INTEGER) is
	do
		put_colour(colour_code_to_colour(c))
	end

	colour_code : INTEGER is
	do
		inspect colour_method
		when 0 then
			Result := fg - 8
		when 1 then
			Result := bg
		end
		if Result < 1 or Result > 7 then
			Result := 7
		end
	end

	colour_method : INTEGER is
		-- how the object is coloured
		-- 0 = foreground (most objects)
		-- 1 = background
	once
		Result := 0
	end

	chr : INTEGER
	put_chr(c : INTEGER) is
	do
		chr := c
	end

	player_touch(p : PLAYER) is
	do
	end

	can_push(d : INTEGER) : BOOLEAN is
	deferred
	end

	try_push(d : INTEGER) : BOOLEAN is
	deferred
	end

	can_push_me(d : INTEGER) : BOOLEAN is
	once
		Result := false
	end

	can_walk_on : BOOLEAN is
	once
		Result := false
	end

	can_convey_me : BOOLEAN is
	once
		Result := false
	end

	can_adjacent_shoot : BOOLEAN is
	once
		Result := false
	end

	blast is
	do
	end

	tick is
	do
	end

	ticking : BOOLEAN
	put_ticking(b : BOOLEAN) is
	do
		ticking := b
	end

	shot(b : BULLET) is
	do
	end

	make_for_world(w : WORLD) is
	do
		w.thing_code.put(Current, zzt_code)
		w.thing_table.put(Current, kind)
	end

	add_to_map(m : MAP; sq : SQUARE; c : INTEGER) is
	local
		t : like Current
	do
		t := instantiate(sq, c)
	end

	instantiate(sq : SQUARE; c : INTEGER) : like Current is
	do
		Result := clone(Current)
		Result.put_colour(c)
		Result.make(sq)
	end

	zzt_code : INTEGER is
		-- code of thing in ZZT file format
	deferred
	end

	kind : STRING is
		-- ZZT kind name
	deferred
	end
end
