class WORLD
inherit
	READ_TOOL
creation make
feature
	board_list : ARRAY[MAP]
	start_ammo : INTEGER
	start_gems : INTEGER
	start_keys : ARRAY[BOOLEAN]
	start_health : INTEGER
	max_key : INTEGER is 7
	start_board : INTEGER
	start_torch : INTEGER
	start_tcycle : INTEGER
	start_ecycle : INTEGER
	start_score : INTEGER

	title : STRING

	make is
	local
		t : THING
	do
		--init tables
		!!thing_code.make(0, 255)
		!!thing_table.make
		!FLOOR!t.make_for_world(Current)
		!AMMO!t.make_for_world(Current)
		!TORCH!t.make_for_world(Current)
		!GEM!t.make_for_world(Current)
		!KEY!t.make_for_world(Current)
		!DOOR!t.make_for_world(Current)
		!SCROLL!t.make_for_world(Current)
		!PASSAGE!t.make_for_world(Current)
		!DUPLICATOR!t.make_for_world(Current)
		!BOMB!t.make_for_world(Current)
		!ENERGIZER!t.make_for_world(Current)
		!STAR!t.make_for_world(Current)
		!CONVEYOR1!t.make_for_world(Current)
		!CONVEYOR2!t.make_for_world(Current)
		!BULLET!t.make_for_world(Current)
		!WATER!t.make_for_world(Current)
		!FOREST!t.make_for_world(Current)
		!SLIDEREW!t.make_for_world(Current)
		!SLIDERNS!t.make_for_world(Current)
		!SOLID_WALL!t.make_for_world(Current)
		!NORMAL_WALL!t.make_for_world(Current)
		!BREAKABLE!t.make_for_world(Current)
		!BOULDER!t.make_for_world(Current)
		!FAKE_WALL!t.make_for_world(Current)
		!INVISIBLE!t.make_for_world(Current)
		!TRANSPORTER!t.make_for_world(Current)
		!LINE!t.make_for_world(Current)
		!RICOCHET!t.make_for_world(Current)
		!BEAR!t.make_for_world(Current)
		!RUFFIAN!t.make_for_world(Current)
		!OBJECT!t.make_for_world(Current)
		!SHARK!t.make_for_world(Current)
		!PUSHER!t.make_for_world(Current)
		!LION!t.make_for_world(Current)
		!TIGER!t.make_for_world(Current)
		!CENTIPEDE_HEAD!t.make_for_world(Current)
		!CENTIPEDE_SEGMENT!t.make_for_world(Current)
	end

	thing_code : ARRAY[THING]
	thing_table : DICTIONARY[THING, STRING]
	
	load_world : BOOLEAN is
	local
		i : INTEGER
		n : INTEGER
		board : MAP
	do
		offset := 0
		read_1
		--check it's 255
		read_1
		--check it's 255
		read_2
		io.put_string("Board max = ")
		io.put_integer(last_integer)
		io.put_string("%N")
		!!board_list.make(0, last_integer)
		read_2
		start_ammo := last_integer
		read_2
		start_gems := last_integer
		!!start_keys.make(1, max_key)
		from i := 1
		until i > max_key
		loop
			read_1
			inspect last_character.code
			when 0 then
				start_keys.put(false, i)
			when 1 then
				start_keys.put(true, i)
			else
				-- error
			end
			i := i + 1
		end
		read_2
		start_health := last_integer
		read_2
		start_board := last_integer
		read_2
		start_torch := last_integer
		read_2
		start_tcycle := last_integer
		read_2
		start_ecycle := last_integer
		read_2
		-- check it's 0
		read_2
		start_score := last_integer
		read_1
		n := last_character.code
		!!title.make(n)
		from i := 1
		until i > n
		loop
			read_1
			title.add_last(last_character)
			i := i + 1
		end
		io.put_string("Title : ")
		io.put_string(title)
		io.put_string("%N")

		read_until(512)

		from i := 0
		until i > board_list.upper
		loop
			!!board.make(Current)
			if verbose_flag then
				io.put_string("reading board #")
				io.put_integer(i)
				io.put_string("%N")
			end
			board.read_board
			board_list.put(board, i)
			i := i + 1
		end
		Result := true
	end

end
